/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.JenisDokumen;
import com.portofolio.entity.vo.JenisDokumenId;

@Lazy
@Repository
public interface JenisDokumenDao extends CrudRepository<JenisDokumen, JenisDokumenId> {

	@Cacheable("JenisDokumenDaofindOneBy")
	JenisDokumen findOneByIdKodeAndIdKdProfileAndKdDepartemen(Integer kode, Integer kdProfile, String KdDepartemen);

	@Query(QListAll)
	@Cacheable("JenisDokumenDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page,
			@Param("kdDepartemen") String kdDepartemen);

	@Query(QListAll + " and model.namaJenisDokumen like %:namaJenisDokumen% ")
	@Cacheable("JenisDokumenDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaJenisDokumen") String namaJenisDokumen, Pageable page,
			@Param("kdDepartemen") String kdDepartemen);

	@Query(QListAll + " and model.id.kode like :kode")
	@Cacheable("JenisDokumenDaoFindByKode")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode,
			@Param("kdDepartemen") String kdDepartemen);

	@Query("select new map(model.id.kode as kdJenisDokumen, model.namaJenisDokumen as namaJenisDokumen ) from JenisDokumen model where model.id.kdProfile=:kdProfile and model.kdJenisDokumenHead = :kode")
	List<Map<String, Object>> findByKodeHead(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode);

	String QListAll = "select new map(model.id.kdJenisDokumen as kdJenisDokumen,model.id.kdProfile as kdProfile " + ", model.namaJenisDokumen as namaJenisDokumen "
			+ ", model.reportDisplay as reportDisplay " + ", model.kdDepartemen as kdDepartemen "
			+ ", model.kdJenisDokumenHead as kdJenisDokumenHead "
			+ ", jenisDokumenHead.namaJenisDokumen as namaJenisDokumenHead "
			+ ", model.retensiDokumenTahun as retensiDokumenTahun " + ", model.kodeExternal as kodeExternal "
			+ ", model.namaExternal as namaExternal " + ", model.statusEnabled as statusEnabled "
			+ ", model.noRec as noRec " + ", departemen.namaDepartemen as namaDepartemen, model.version as version )"
			+ " from JenisDokumen model left join model.id id " + " left join model.jenisDokumenHead jenisDokumenHead "
			+ " left join model.departemen departemen where id.kdProfile=:kdProfile and departemen.id.kdProfile=id.kdProfile and model.kdDepartemen = :kdDepartemen ";

	@Query("select new map(model.id.kode as kdJenisDokumen, model.namaJenisDokumen as namaJenisDokumen ) from JenisDokumen model where model.id.kdProfile=:kdProfile and  model.statusEnabled = true ")
	List<Map<String, Object>>  findAllData(@Param("kdProfile")  Integer kdProfile);

}
